include( ../../common.pri )
include( ../../app.pri )

QT       += core gui network

QMAKE_LFLAGS_RELEASE += -static -static-libgcc -static-libstdc++

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = Legacy-advanced
TEMPLATE = app

CXXFLAGS += -O2 -fno-stack-limit
CONFIG += resources_big

# The following define makes your compiler emit warnings if you use
# any feature of Qt which has been marked as deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if you use deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0


SOURCES += \
    main.cpp \
    models\downloader.cpp \
    models\filesystem.cpp \
    models\lotromanager.cpp \
    widgets\browsewidget.cpp \
    widgets\exportwidget.cpp \
    widgets\importwidget.cpp \
    widgets\mainwindow.cpp \
    widgets\managewidget.cpp \
    widgets\menuentry.cpp \
    widgets\messagedialog.cpp \
    widgets\lotroprogresswidget.cpp

HEADERS += \
    models\downloader.h \
    models\filesystem.h \
    models\lotromanager.h \
    widgets\browsewidget.h \
    widgets\exportwidget.h \
    widgets\importwidget.h \
    widgets\mainwindow.h \
    widgets\managewidget.h \
    widgets\menuentry.h \
    widgets\messagedialog.h \
    widgets\lotroprogresswidget.h

FORMS += \
    widgets\browsewidget.ui \
    widgets\exportwidget.ui \
    widgets\importwidget.ui \
    widgets\mainwindow.ui \
    widgets\managewidget.ui \
    widgets\messagedialog.ui \
    widgets\lotroprogresswidget.ui

win32:RC_ICONS = $${PROJECT_ROOT_PATH}/resources/appicon.ico

INCLUDEPATH += $$PWD/src
INCLUDEPATH += $$PWD/widgets

LIBS += -llibLotroDat_static
LIBS += -llibyaml-cpp
LIBS += -llibzlibstatic


CONFIG(debug, debug|release) {
        RESOURCES += \
                $${PROJECT_ROOT_PATH}/resources/backgrounds.qrc \
                $${PROJECT_ROOT_PATH}/resources/common.qrc
} else {
        include(../../build_res.pri)
}
