include( ../../common.pri )
include( ../../app.pri )

QT       += core gui network

QMAKE_LFLAGS_RELEASE += -static -static-libgcc -static-libstdc++

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = Legacy
TEMPLATE = app

CXXFLAGS += -O2 -fno-stack-limit
CONFIG += resources_big

SOURCES += \
    main.cpp \
    models/downloader.cpp \
    models/filesystem.cpp \
    models/lotromanager.cpp \
    widgets/helpwidget.cpp \
    widgets/mainwindow.cpp \
    widgets/menuentry.cpp \
    widgets/newswidget.cpp \
    widgets/rusificationtreeitem.cpp \
    widgets/rusificationwidget.cpp \
    widgets/settingswidget.cpp \
    widgets/statuswidget.cpp

HEADERS += \
    models/downloader.h \
    models/filesystem.h \
    models/lotromanager.h \
    widgets/helpwidget.h \
    widgets/mainwindow.h \
    widgets/menuentry.h \
    widgets/newswidget.h \
    widgets/rusificationtreeitem.h \
    widgets/rusificationwidget.h \
    widgets/settingswidget.h \
    widgets/statuswidget.h

FORMS += \
    widgets/helpwidget.ui \
    widgets/mainwindow.ui \
    widgets/newswidget.ui \
    widgets/rusificationwidget.ui \
    widgets/settingswidget.ui \
    widgets/statuswidget.ui

win32:RC_ICONS = $${PROJECT_ROOT_PATH}/resources/appicon.ico

INCLUDEPATH += $$PWD/src
INCLUDEPATH += $$PWD/gui

LIBS += -llibLotroDat_static
LIBS += -llibyaml-cpp
LIBS += -llibzlibstatic


CONFIG(debug, debug|release) {
        RESOURCES += \
                $${PROJECT_ROOT_PATH}/resources/backgrounds.qrc \
                $${PROJECT_ROOT_PATH}/resources/common.qrc
} else {
        include(../../build_res.pri)
}
